*---------------------------------------------------------------------------------------*
* g_line : `									*
*		98-01-19 Ver 1.0							*
*											*
*	 : int (x0,y0),(x1,y1)  ̗[̍W					*
*	       int col              J[io[					*
*											*
*	߂l : d0 =   0  I							*
*		      -50  p[^[G[					*
*		      -40  uq`l̎gp֎~					*
*---------------------------------------------------------------------------------------*

		.include	iocscall.mac
		.include	errnum.h

		.xdef		_g_line
		.xdef		g_line_main
		.xref		g_xyadr
		.xref		g_check
		.xref		g_mode

		.offset		8		* _g_line()p

_X0:		ds.l		1
_Y0:		ds.l		1
_X1:		ds.l		1
_Y1:		ds.l		1
_COL:		ds.l		1

		.offset		8		* g_line_mainp

X0:		ds.w		1
Y0:		ds.w		1
X1:		ds.w		1
Y1:		ds.w		1
COL:		ds.w		1

iocs		equ		$0f

		.text
		.even

_g_line:
		bsr		g_check
		tst.l		d0
		beq		@F

		rts
@@:
		link		a6,#0
		movem.l		d1-d7/a0-a3,-(sp)

		subq.l		#8,sp
		bsr		g_mode
		movem.l		(sp)+,d6-d7		* d7 : line width (512 or 1024)

		movem.l		_X0(a6),d1-d5		* (d1,d2) = (X0,Y0)
		cmp.l		d6,d5			* (d3,d4) = (X1,Y1)
		bcc		par_error		* d5 = COLOR

		cmp.l		d1,d3			* X0 > X1 ȂW
		bgt		@F
		exg.l		d1,d3
		exg.l		d2,d4

@@:		move.l		#32767,d0		* d0 : MAX
		move.l		#-32768,d6		* d6 : MIN
		cmp.l		d6,d1			* MIN < X0 ?
		blt		par_error
		cmp.l		d0,d3			* MAX > X1 ?
		bgt		par_error
		cmp.l		d6,d2			* MIN < Y0 ?
		blt		par_error
		cmp.l		d0,d2			* MAX > Y0 ?
		bgt		par_error
		cmp.l		d6,d4			* MIN < Y1 ?
		blt		par_error
		cmp.l		d0,d4			* MAX > Y1 ?
		bgt		par_error

		bra		ent

g_line_main:
		bsr		g_check
		tst.l		d0
		beq		@F

		rts
@@:
		link		a6,#0
		movem.l		d1-d7/a0-a3,-(sp)

		subq.l		#8,sp
		bsr		g_mode
		movem.l		(sp)+,d6-d7		* d7 : line width (512 or 1024)

		movem.w		X0(a6),d1-d5		* (d1,d2) = (X0,Y0)
							* (d3,d4) = (X1,Y1)
		cmp.w		d1,d3			* d5 : COL
		bgt		ent			* X0 > X1 ȂW
		exg.l		d1,d3
		exg.l		d2,d4

		subq.w		#1,d6
		cmp.w		d6,d5
		bhi		par_error

ent:
		lea.l		CLIPRECT,a0		* NbsOW
		move.l		#$80008000,(a0)+	* (MINX,MINY) = (0,0)
		move.w		d7,d0
		add.w		#$7FFF,d0
		move.w		d0,(a0)+		* (MAXX,MAXY) : line width
		move.w		d0,(a0)
		movem.l		d5/d7,-(sp)		* d5,d7ޔ
		bsr		clipping
		movem.l		(sp)+,d5/d7		* d5,d7𕜋A
		movea.l		#-1,a1
		tst.l		d0
		bne		done

		moveq.l		#_B_SUPER,d0
		clr.l		a1
		trap		#iocs
		movea.l		d0,a1			* a1 : USP

		ext.l		d1			* ʃ[hNA
		ext.l		d2
		ext.l		d3
		ext.l		d4
		movem.l		d1-d2,-(sp)
		bsr		g_xyadr
		addq.l		#8,sp
		movea.l		d0,a2			* a2 : n_̃AhX
		movem.l		d3-d4,-(sp)
		bsr		g_xyadr
		addq.l		#8,sp
		movea.l		d0,a3			* a3 : I_̃AhX

		move.w		d5,d0			* d5̏ʃoCgFR[hZbg
		swap		d5
		move.w		d0,d5
		add.w		d7,d7			* d7 : line width (Byte)
		sub.w		d1,d3			* d3 = dx = |X1 - X0|
		beq		vline			* dx=0Ȃ琂
		sub.w		d2,d4			* d4 = dy = |Y1 - Y0|
		beq		hline			* dy=0Ȃ琅
		bgt		@F
		neg.w		d4
		neg.w		d7			* dy<0ȂxW̑

@@:		cmp.w		d3,d4
		bhi		yline

xline:		* dxdy̏ꍇ
		addq.l		#2,a3			* fNg镪␳
		move.w		d3,d0			* d0 = E
		neg.w		d0
		move.w		d3,d1			* d1 = 2dx
		add.w		d1,d1
		add.w		d4,d4			* d4 = 2dy
		move.w		d4,d2			* d2 = 4dy
		add.w		d2,d2

		addq.w		#1,d3			* d3 = ̃sNZ
		moveq.l		#3,d6			* d6 = ̃sNZ mod 4
		and.w		d3,d6
		lsr.w		#2,d3			* [vJE^ 1/4
		subq.w		#1,d3			* dbra̓l
		bmi		xlineq			* SsNZ̏ꍇ

		cmp.w		d1,d2			* 2dx4dyȂxline3
		bcc		xline3

xline0:		* dy/dx < 1/2̏ꍇ
		add.w		d2,d0			* E += 4dy
		bpl		xline1			* E>0 Ȃ xline1

		*
		* 
		*
		move.l		d5,(a2)+		* PSET(X0++,Y0),PSET(X0++,Y0)
		move.l		d5,-(a3)		* PSET(X1--,Y1),PSET(X1--,Y1)

		dbra		d3,xline0
		bra		xlineq

xline1:
		cmp.w		d4,d0			* 2dyEȂxline2
		bge		xline2
		*     
		* 
		*
		move.l		d5,(a2)+		* PSET(X0++,Y0),PSET(X0++,Y0)
		move.l		d5,-(a3)		* PSET(X1--,Y1),PSET(X1--,Y1)
		adda.w		d7,a2			* Y0++(Y0--)
		suba.w		d7,a3			* Y1--(Y1++)
		sub.w		d1,d0			* E -= 2dx

		dbra		d3,xline0
		bra		xlineq

xline2:
		*   
		* 
		*
		move.w		d5,(a2)+		* PSET(X0++,Y0)
		move.w		d5,-(a3)		* PSET(X1--,Y1)
		adda.w		d7,a2			* Y0++(Y0--)
		suba.w		d7,a3			* Y1--(Y1++)
		move.w		d5,(a2)+		* PSET(X0++,Y0)
		move.w		d5,-(a3)		* PSET(X1--,Y1)
		sub.w		d1,d0			* E -= 2dx

		dbra		d3,xline0
		bra		xlineq

xline3:		* 1/2dy/dx1̏ꍇ
		sub.w		d1,d2			* d2 = 4dy - 2dx
		sub.w		d1,d4			* d4 = 2dy - 2dx

xline4:
		add.w		d2,d0			* E += (4dy - 2dx)
		bmi		xline5			* E<0 Ȃ xline5

		*     
		*   
		* 
		move.w		d5,(a2)+		* PSET(X0++,Y0)
		move.w		d5,-(a3)		* PSET(X1--,Y1)
		adda.w		d7,a2			* Y0++(Y0--)
		suba.w		d7,a3			* Y1--(Y1++)
		move.w		d5,(a2)+		* PSET(X0++,Y0)
		move.w		d5,-(a3)		* PSET(X1--,Y1)
		adda.w		d7,a2			* Y0++(Y0--)
		suba.w		d7,a3			* Y1--(Y1++)
		sub.w		d1,d0			* E -= 2dx

		dbra		d3,xline4
		bra		xlineq2

xline5:
		cmp.w		d4,d0			* (2dy - 2dx)EȂxline6
		bge		xline6
		*     
		* 
		*
		move.l		d5,(a2)+		* PSET(X0++,Y0),PSET(X0++,Y0)
		move.l		d5,-(a3)		* PSET(X1--,Y1),PSET(X1--,Y1)
		adda.w		d7,a2			* Y0++(Y0--)
		suba.w		d7,a3			* Y1--(Y1++)

		dbra		d3,xline4
		bra		xlineq2

xline6:
		*   
		* 
		*
		move.w		d5,(a2)+		* PSET(X0++,Y0)
		move.w		d5,-(a3)		* PSET(X1--,Y1)
		adda.w		d7,a2			* Y0++(Y0--)
		suba.w		d7,a3			* Y1--(Y1++)
		move.w		d5,(a2)+		* PSET(X0++,Y0)
		move.w		d5,-(a3)		* PSET(X1--,Y1)

		dbra		d3,xline4

xlineq2:
		add.w		d1,d4			* d4 = 2dy

xlineq:							* SsNZ̒[`
		add.w		d6,d6
		move.w		xtbl(pc,d6),d6
		jmp		xtbl(pc,d6)

xtbl:
XT		=		xtbl
		.dc.w		done-XT
		.dc.w		xleft1-XT
		.dc.w		xleft2-XT
		.dc.w		xleft3-XT

xleft3:							* cRsNZ
		move.w		d5,(a2)+
		add.w		d4,d0
		bmi		xleft2
		adda.w		d7,a2
xleft2:							* cQsNZ
		move.w		d5,-(a3)
xleft1:							* cPsNZ
		move.w		d5,(a2)
		bra		done

yline:		* dx<dy̏ꍇ
		movea.w		d7,a0			* a0 : x,yωGRAM
		addq.l		#2,a0

		move.w		d4,d0			* d0 = E
		neg.w		d0
		move.w		d4,d1			* d1 = 2dy
		add.w		d1,d1
		add.w		d3,d3			* d3 = 2dx
		move.w		d3,d2			* d2 = 4dx
		add.w		d2,d2

		addq.w		#1,d4			* d4 = ̃sNZ
		moveq.l		#3,d6			* d6 = ̃sNZ mod 4
		and.w		d4,d6
		lsr.w		#2,d4			* [vJE^ 1/4
		subq.w		#1,d4			* dbra̓l
		bmi		ylineq			* SsNZ̏ꍇ

		cmp.w		d1,d2			* 2dy4dxȂyline3
		bcc		yline3

yline0:		* dx/dy < 1/2̏ꍇ
		add.w		d2,d0			* E += 4dx
		bpl		yline1			* E>0 Ȃ yline1

		* 
		* 
		* 
		move.w		d5,(a2)			* PSET(X0,Y0),PSET(X0,Y0)
		move.w		d5,(a3)			* PSET(X1,Y1),PSET(X1,Y1)
		adda.w		d7,a2			* Y0++(Y0--)
		suba.w		d7,a3			* Y1--(Y1++)
		move.w		d5,(a2)			* PSET(X0,Y0),PSET(X0,Y0)
		move.w		d5,(a3)			* PSET(X1,Y1),PSET(X1,Y1)
		adda.w		d7,a2			* Y0++(Y0--)
		suba.w		d7,a3			* Y1--(Y1++)

		dbra		d4,yline0
		bra		ylineq

yline1:
		cmp.w		d3,d0			* 2dxEȂxline2
		bge		yline2
		*   
		* 
		* 
		move.w		d5,(a2)			* PSET(X0,Y0)
		move.w		d5,(a3)			* PSET(X1,Y1)
		adda.w		d7,a2			* Y0++(Y0--)
		suba.w		d7,a3			* Y1--(Y1++)
		move.w		d5,(a2)			* PSET(X0,Y0)
		move.w		d5,(a3)			* PSET(X1,Y1)
		adda.w		a0,a2			* X0++(X0--) ; Y0++(Y0--)
		suba.w		a0,a3			* X1--(X1++) ; Y1--(Y1++)
		sub.w		d1,d0			* E -= 2dy

		dbra		d4,yline0
		bra		ylineq

yline2:
		*   
		*   
		* 
		move.w		d5,(a2)			* PSET(X0,Y0)
		move.w		d5,(a3)			* PSET(X1,Y1)
		adda.w		a0,a2			* X0++(X0--) ; Y0++(Y0--)
		suba.w		a0,a3			* X1--(X1++) ; Y1--(Y1++)
		move.w		d5,(a2)			* PSET(X0,Y0)
		move.w		d5,(a3)			* PSET(X1,Y1)
		adda.w		d7,a2			* Y0++(Y0--)
		suba.w		d7,a3			* Y1--(Y1++)
		sub.w		d1,d0			* E -= 2dy

		dbra		d4,yline0
		bra		ylineq

yline3:		* 1/2dx/dy1̏ꍇ
		sub.w		d1,d2			* d2 = 4dx - 2dy
		sub.w		d1,d3			* d3 = 2dx - 2dy

yline4:
		add.w		d2,d0			* E += (4dx - 2dy)
		bmi		yline5			* E<0 Ȃ yline5

		*     
		*   
		* 
		move.w		d5,(a2)			* PSET(X0,Y0)
		move.w		d5,(a3)			* PSET(X1,Y1)
		adda.w		a0,a2			* X0++(X0--) ; Y0++(Y0--)
		suba.w		a0,a3			* X1--(X1++) ; Y1--(Y1++)
		move.w		d5,(a2)			* PSET(X0,Y0)
		move.w		d5,(a3)			* PSET(X1,Y1)
		adda.w		a0,a2			* X0++(X0--) ; Y0++(Y0--)
		suba.w		a0,a3			* X1--(X1++) ; Y1--(Y1++)
		sub.w		d1,d0			* E -= 2dy

		dbra		d4,yline4
		bra		ylineq2

yline5:
		cmp.w		d3,d0			* (2dx - 2dy)EȂyline6
		bge		yline6
		*   
		* 
		* 
		move.w		d5,(a2)			* PSET(X0,Y0)
		move.w		d5,(a3)			* PSET(X1,Y1)
		adda.w		d7,a2			* Y0++(Y0--)
		suba.w		d7,a3			* Y1--(Y1++)
		move.w		d5,(a2)			* PSET(X0,Y0)
		move.w		d5,(a3)			* PSET(X1,Y1)
		adda.w		a0,a2			* X0++(X0--) ; Y0++(Y0--)
		suba.w		a0,a3			* X1--(X1++) ; Y1--(Y1++)

		dbra		d4,yline4
		bra		ylineq2

yline6:
		*   
		*   
		* 
		move.w		d5,(a2)			* PSET(X0,Y0)
		move.w		d5,(a3)			* PSET(X1,Y1)
		adda.w		a0,a2			* X0++(X0--) ; Y0++(Y0--)
		suba.w		a0,a3			* X1--(X1++) ; Y1--(Y1++)
		move.w		d5,(a2)			* PSET(X0,Y0)
		move.w		d5,(a3)			* PSET(X1,Y1)
		adda.w		d7,a2			* Y0++(Y0--)
		suba.w		d7,a3			* Y1--(Y1++)

		dbra		d4,yline4

ylineq2:
		add.w		d1,d3			* d3 = 2dx

ylineq:							* SsNZ̒[`
		add.w		d6,d6
		move.w		ytbl(pc,d6),d6
		jmp		ytbl(pc,d6)

ytbl:
YT		=		ytbl
		.dc.w		done-YT
		.dc.w		yleft1-YT
		.dc.w		yleft2-YT
		.dc.w		yleft3-YT

yleft3:							* cRsNZ
		add.w		d3,d0
		bmi		@F
		move.w		d5,0(a2,a0)
		bra		yleft2
@@:		move.w		d5,0(a2,d7)
yleft2:							* cQsNZ
		move.w		d5,(a3)
yleft1:							* cPsNZ
		move.w		d5,(a2)
		bra		done

vline:
		sub.w		d2,d4			* d4 = dy = |Y1 - Y0|
		bgt		vloop
		neg.w		d4
		neg.w		d7			* dy<0ȂxW̑

vloop:
		move.w		d5,(a2)
		adda.w		d7,a2

		dbra		d4,vloop
		bra		done

hline:
		lsr.w		#1,d3
		scc		d0
		bcs		@F
		subq.l		#1,d3

@@:		move.l		d5,(a2)+

		dbra		d3,@B
		tst.b		d0
		beq		done
		move.w		d5,(a2)

done:
		cmpa.l		#-1,a1
		beq		@F
		moveq.l		#_B_SUPER,d0
		trap		#iocs

@@:		movem.l		(sp)+,d1-d7/a0-a3
		unlk		a6
		moveq.l		#0,d0

		rts

par_error:
		movem.l		(sp)+,d1-d7/a0-a3
		unlk		a6
		moveq.l		#PAR_ERR,d0

		rts

VRAM_use_error:
		moveq.l		#VRAM_USE_ERR,d0

		rts

* ̋`̈NbsO
* (d1,d2)-(d3,d4)`̈(a0,a1)-(a2,a3)ŃNbv
* Ss̏ꍇd0=-1Ŗ߂

clipping:
		movem.w		CLIPRECT,a0-a3	* NbsOEBhE(Q^)
		move.w		#$8000,d0	* Q^𗚂
		add.w		d0,d1
		add.w		d0,d2
		add.w		d0,d3
		add.w		d0,d4

		bsr		gclip		* n_Nbv
		bne		@F		* s

		exg.l		d1,d3		* n_ƏI_ꊷ
		exg.l		d2,d4
		bsr		gclip		* I_Nbv
		bne		@F		* s
		exg.l		d1,d3		* n_ƏI_ɖ߂
		exg.l		d2,d4

		move.w		#$8000,d0	* Q^E
		sub.w		d0,d1
		sub.w		d0,d2
		sub.w		d0,d3
		sub.w		d0,d4

		moveq.l		#0,d0		* Z = 1
@@:		rts

gclip:		* [_(d1,d2)NbsO
		move.w		d1,d5		* d1,d2ޔ
		move.w		d2,d6

minx:		* MINXŃNbsO
		cmp.w		a0,d1		* MINXd1Ȃminy
		bcc		miny
		cmp.w		a0,d3		* MINX>d1 and MINX>d3Ȃ犮Ss
		bcc		@F
		moveq.l		#-1,d0		* Z = 0
		rts

@@:		move.w		a0,d0		* d0 = MINX
		moveq.l		#0,d7
		sub.w		d3,d1		* d1 = |X0 - X1|
		bcc		@F
		neg.w		d1
		addq.w		#1,d7

@@:		sub.w		d4,d2		* d2 = |Y0 - Y1|
		bcc		@F
		neg.w		d2
		addq.w		#1,d7

@@:		sub.w		d5,d0		* d0 = |X0 - MINX|
		bcc		@F
		neg.w		d0
		addq.w		#1,d7

@@:		mulu.w		d0,d2		* d2 = |Y0 - Y1| * |X0 - MINX|
		divu.w		d1,d2		*    / |X0 - X1|
		btst.l		#0,d7
		beq		@F
		neg.w		d2

@@:		add.w		d6,d2		* d2 = MINXɑΉxW
		move.w		a0,d1		* d1 = MINX

miny:		* MINYŃNbsO
		cmp.w		a1,d2		* MINYd2Ȃmaxx
		bcc		maxx
		cmp.w		a1,d4		* MINY>d2 and MINY>d4Ȃ犮Ss
		bcc		@F
		moveq.l		#-1,d0		* Z = 0
		rts

@@:		move.w		a1,d0		* d0 = MINY
		moveq.l		#0,d7
		move.w		d6,d2		* d2ɖ߂
		sub.w		d4,d2		* d2 = |Y0 - Y1|
		bcc		@F
		neg.w		d2
		addq.w		#1,d7

@@:		move.w		d5,d1		* d1ɖ߂
		sub.w		d3,d1		* d1 = |X0 - X1|
		bcc		@F
		neg.w		d1
		addq.w		#1,d7

@@:		sub.w		d6,d0		* d0 = |Y0 - MINY|
		bcc		@F
		neg.w		d0
		addq.w		#1,d7

@@:		mulu.w		d0,d1		* d1 = |X0 - X1| * |Y0 - MINY|
		divu.w		d2,d1		*    / |Y0 - Y1|
		btst.l		#0,d7
		beq		@F
		neg.w		d1

@@:		add.w		d5,d1		* d1 = MINYɑΉwW
		cmp.w		a0,d1		* MINX>d1Ȃ犮Ss
		bcc		@F
		moveq.l		#-1,d0		* Z = 0
		rts
@@:		move.w		a1,d2		* d2 = MINY

maxx:		* MAXXŃNbsO
		cmp.w		a2,d1		* MAXXd1Ȃmaxy
		bls		maxy
		cmp.w		a2,d3		* MAXX<d1 and MAXX<d3Ȃ犮Ss
		bls		@F
		moveq.l		#-1,d0		* Z = 0
		rts

@@:		move.w		a2,d0		* d0 = MAXX
		moveq.l		#0,d7
		move.w		d5,d1		* d1ɖ߂
		sub.w		d3,d1		* d1 = |X0 - X1|
		bcc		@F
		neg.w		d1
		addq.w		#1,d7

@@:		move.w		d6,d2		* d2ɖ߂
		sub.w		d4,d2		* d2 = |Y0 - Y1|
		bcc		@F
		neg.w		d2
		addq.w		#1,d7

@@:		sub.w		d5,d0		* d0 = |X0 - MINX|
		bcc		@F
		neg.w		d0
		addq.w		#1,d7

@@:		mulu.w		d0,d2		* d2 = |Y0 - Y1| * |X0 - MINX|
		divu.w		d1,d2		*    / |X0 - X1|
		btst.l		#0,d7
		beq		@F
		neg.w		d2

@@:		add.w		d6,d2		* d2 = MAXXɑΉxW
		cmp.w		a1,d2
		bcc		@F
		moveq.l		#-1,d0		* Z = 0
		rts
@@:		move.w		a2,d1		* d1 = MAXX

maxy:		* MAXYŃNbsO
		cmp.w		a3,d2		* MAXYd2Ȃ犮S
		bhi		@F
		moveq.l		#0,d0		* Z = 1
		rts
@@:		cmp.w		a3,d4		* MAXY<d2 and MAXY<d4Ȃ犮Ss
		bls		@F
		moveq.l		#-1,d0		* Z = 0
		rts

@@:		move.w		a3,d0		* d0 = MAXY
		moveq.l		#0,d7
		move.w		d6,d2		* d2ɖ߂
		sub.w		d4,d2		* d2 = |Y0 - Y1|
		bcc		@F
		neg.w		d2
		addq.w		#1,d7

@@:		move.w		d5,d1		* d1ɖ߂
		sub.w		d3,d1		* d1 = |X0 - X1|
		bcc		@F
		neg.w		d1
		addq.w		#1,d7

@@:		sub.w		d6,d0		* d0 = |Y0 - MAXY|
		bcc		@F
		neg.w		d0
		addq.w		#1,d7

@@:		mulu.w		d0,d1		* d1 = |X0 - X1| * |Y0 - MAXY|
		divu.w		d2,d1		*    / |Y0 - Y1|
		btst.l		#0,d7
		beq		@F
		neg.w		d1

@@:		add.w		d5,d1		* d1 = MAXYɑΉwW
		cmp.w		a0,d1		* MINX>d1Ȃ犮Ss
		bcc		@F
		moveq.l		#-1,d0		* Z = 0
		rts
@@:		cmp.w		a2,d1		* MAXX<d1Ȃ犮Ss
		bls		@F
		moveq.l		#-1,d0		* Z = 0
		rts
@@:		move.w		a3,d2		* d2 = MAXY

		moveq.l		#0,d0		* Z = 1
		rts

		.data
		.even

CLIPRECT:	ds.w		4

		.end